"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var cross_spawn_1 = __importDefault(require("cross-spawn"));
var querystring_1 = __importDefault(require("querystring"));
var util_1 = require("../util");
var command = process.argv[2];
var args = process.argv.slice(3);
var _a = command.split('?'), script = _a[0], _b = _a[1], paramsStr = _b === void 0 ? '' : _b;
var query = querystring_1.default.parse(paramsStr);
var params = (0, util_1.getKeys)(query).map(function (key) {
    return query[key] ? "--".concat(key, "=").concat(query[key]) : "--".concat(key);
});
var result = void 0;
var nodeMajorVersion = Number(process.versions.node.split('.')[0]);
switch (script) {
    case 'build':
    case 'start':
    case 'test':
        result = cross_spawn_1.default.sync('node', __spreadArray(__spreadArray(__spreadArray([
            nodeMajorVersion >= 18 ? '--openssl-legacy-provider' : ''
        ], params, true), [
            require.resolve('../scripts/' + script)
        ], false), args, true).filter(Boolean), {
            stdio: 'inherit',
        });
        break;
    default:
        console.log('Unknown script "' + script + '".');
        break;
}
if (result) {
    switch (result.signal) {
        case 'SIGKILL':
            console.log('The build failed because the process exited too early. ' +
                'This probably means the system ran out of memory or someone called ' +
                '`kill -9` on the process.');
            process.exit(1);
            break;
        case 'SIGTERM':
            console.log('The build failed because the process exited too early. ' +
                'Someone might have called `kill` or `killall`, or the system could ' +
                'be shutting down.');
            process.exit(1);
            break;
    }
    process.exit(result.status);
}
