"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getHashFilename = exports.revPath = exports.replace = exports.readAssets = exports.getAssets = exports.replaceManifestInDir = exports.revStaticAssets = exports.getHtmlCssJsFiles = exports.getAllFiles = void 0;
var fast_glob_1 = __importDefault(require("fast-glob"));
var path_1 = __importDefault(require("path"));
var crypto_1 = __importDefault(require("crypto"));
var fs_extra_1 = __importDefault(require("fs-extra"));
var getAllFiles = function (dir) { return __awaiter(void 0, void 0, void 0, function () {
    var files;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, (0, fast_glob_1.default)(["**/*"], {
                    cwd: dir
                })];
            case 1:
                files = _a.sent();
                return [2 /*return*/, files.map(function (file) { return file.replaceAll(path_1.default.sep, '/'); })];
        }
    });
}); };
exports.getAllFiles = getAllFiles;
/**
 * get html/css/javascript in target dir
 */
var getHtmlCssJsFiles = function (dir) { return __awaiter(void 0, void 0, void 0, function () {
    var files;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, (0, fast_glob_1.default)(["**/*.@(html|css|js|map)"], {
                    cwd: dir
                })];
            case 1:
                files = _a.sent();
                return [2 /*return*/, files.map(function (file) { return file.replaceAll(path_1.default.sep, '/'); })];
        }
    });
}); };
exports.getHtmlCssJsFiles = getHtmlCssJsFiles;
var revStaticAssets = function (staticDir) { return __awaiter(void 0, void 0, void 0, function () {
    var files, manifest;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, (0, exports.getAllFiles)(staticDir)];
            case 1:
                files = _a.sent();
                manifest = {};
                return [4 /*yield*/, Promise.all(files.map(function (filePath) { return __awaiter(void 0, void 0, void 0, function () {
                        var fullFilePath, fileContent, revFilePath, fullRevFilePath;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    fullFilePath = path_1.default.join(staticDir, filePath);
                                    return [4 /*yield*/, fs_extra_1.default.readFile(fullFilePath)];
                                case 1:
                                    fileContent = _a.sent();
                                    return [4 /*yield*/, getHashFilename(filePath, fileContent)];
                                case 2:
                                    revFilePath = _a.sent();
                                    fullRevFilePath = path_1.default.join(staticDir, revFilePath);
                                    return [4 /*yield*/, Promise.all([
                                            fs_extra_1.default.writeFile(fullRevFilePath, fileContent),
                                            fs_extra_1.default.remove(fullFilePath)
                                        ])];
                                case 3:
                                    _a.sent();
                                    manifest[filePath] = revFilePath;
                                    return [2 /*return*/];
                            }
                        });
                    }); }))];
            case 2:
                _a.sent();
                return [2 /*return*/, manifest];
        }
    });
}); };
exports.revStaticAssets = revStaticAssets;
var replaceManifestInDir = function (replaceDir, manifest) { return __awaiter(void 0, void 0, void 0, function () {
    var htmlCssJsFiles;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, (0, exports.getHtmlCssJsFiles)(replaceDir)];
            case 1:
                htmlCssJsFiles = _a.sent();
                return [4 /*yield*/, Promise.all(htmlCssJsFiles.map(function (filePath) { return __awaiter(void 0, void 0, void 0, function () {
                        var fullFilePath, fileContent, revFileContent;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    fullFilePath = path_1.default.join(replaceDir, filePath);
                                    return [4 /*yield*/, fs_extra_1.default.readFile(fullFilePath, 'utf-8')];
                                case 1:
                                    fileContent = _a.sent();
                                    revFileContent = replace(fileContent, manifest);
                                    if (!(fileContent !== revFileContent)) return [3 /*break*/, 3];
                                    return [4 /*yield*/, fs_extra_1.default.writeFile(fullFilePath, revFileContent)];
                                case 2:
                                    _a.sent();
                                    _a.label = 3;
                                case 3: return [2 /*return*/];
                            }
                        });
                    }); }))];
            case 2:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); };
exports.replaceManifestInDir = replaceManifestInDir;
function getAssets(stats) {
    return Object.keys(stats).reduce(function (result, assetName) {
        var value = stats[assetName];
        result[assetName] = Array.isArray(value) ? value[0] : value;
        return result;
    }, {});
}
exports.getAssets = getAssets;
function readAssets(config) {
    var result;
    // 生产模式直接用编译好的资源表
    var assetsPathList = [
        // 在 publish 目录下启动
        path_1.default.join(config.root, config.static, config.assetsPath),
        // 在项目根目录下启动
        path_1.default.join(config.root, config.publish, config.static, config.assetsPath),
    ];
    while (assetsPathList.length) {
        try {
            var itemPath = assetsPathList.shift();
            if (itemPath) {
                result = require(itemPath);
            }
        }
        catch (error) {
            // ignore error
        }
    }
    if (!result) {
        throw new Error('找不到 webpack 资源表 assets.json');
    }
    return getAssets(result);
}
exports.readAssets = readAssets;
function escapeStringRegexp(string) {
    // reference: https://github.com/sindresorhus/escape-string-regexp/blob/main/index.js
    // Escape characters with special meaning either inside or outside character sets.
    // Use a simple backslash escape when it’s always valid, and a `\xnn` escape when the simpler form would be disallowed by Unicode patterns’ stricter grammar.
    return string
        .replace(/[|\\{}()[\]^$+*?.]/g, '\\$&')
        .replace(/-/g, '\\x2d');
}
function replace(contents, manifest) {
    var newContents = contents;
    // from long to short to avoid shorter path replace longer path
    var entries = Object.entries(manifest).sort(function (a, b) { return b[0].length - a[0].length; });
    for (var _i = 0, entries_1 = entries; _i < entries_1.length; _i++) {
        var _a = entries_1[_i], originalPath = _a[0], revisionPath = _a[1];
        var regexp = new RegExp("(?<![\\w-])".concat(escapeStringRegexp(originalPath), "(?![\\w.])"), 'g');
        newContents = newContents.replace(regexp, revisionPath);
    }
    return newContents;
}
exports.replace = replace;
function modifyFilename(inputPath, modifier) {
    var fileExtension = path_1.default.extname(inputPath);
    return path_1.default.join(path_1.default.dirname(inputPath), modifier(path_1.default.basename(inputPath, fileExtension), fileExtension));
}
function revPath(path, hash) {
    return modifyFilename(path, function (filename, fileExtension) { return "".concat(filename, "-").concat(hash).concat(fileExtension); });
}
exports.revPath = revPath;
function revisionHash(data) {
    return crypto_1.default.createHash('md5').update(data).digest('hex').slice(0, 10);
}
exports.default = revisionHash;
function getHashFilename(originalPath, contents) {
    var revHash = revisionHash(contents);
    var newPath = modifyFilename(originalPath, function (filename, extension) {
        var extIndex = filename.lastIndexOf('.');
        filename = extIndex === -1 ?
            revPath(filename, revHash) :
            revPath(filename.slice(0, extIndex), revHash) + filename.slice(extIndex);
        return filename + extension;
    });
    return newPath.replaceAll(path_1.default.sep, '/');
}
exports.getHashFilename = getHashFilename;
