"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.checkFilename = void 0;
var checkFilename = function (filename, rules) {
    if (!rules) {
        return !filename.includes('node_modules');
    }
    var isMatched = false;
    for (var _i = 0, rules_1 = rules; _i < rules_1.length; _i++) {
        var rule = rules_1[_i];
        if (typeof rule === 'string') {
            if (filename.includes(rule)) {
                isMatched = true;
                break;
            }
        }
        else if (typeof rule === 'function') {
            if (rule(filename)) {
                isMatched = true;
                break;
            }
        }
        else {
            if (rule.test(filename)) {
                isMatched = true;
                break;
            }
        }
    }
    return isMatched;
};
exports.checkFilename = checkFilename;
