"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var resolve_1 = __importDefault(require("resolve"));
var webpack_1 = __importDefault(require("webpack"));
var terser_webpack_plugin_1 = __importDefault(require("terser-webpack-plugin"));
// @ts-ignore
var pnp_webpack_plugin_1 = __importDefault(require("pnp-webpack-plugin"));
var webpack_manifest_plugin_1 = __importDefault(require("webpack-manifest-plugin"));
var webpack_node_externals_1 = __importDefault(require("webpack-node-externals"));
var webpack_bundle_analyzer_1 = require("webpack-bundle-analyzer");
var fork_ts_checker_webpack_plugin_1 = __importDefault(require("fork-ts-checker-webpack-plugin"));
var compileNodeModules_1 = require("./compileNodeModules");
function createWebpackConfig(options, isServer) {
    var _a, _b, _c;
    if (isServer === void 0) { isServer = false; }
    return __awaiter(this, void 0, void 0, function () {
        var result, config, root, alias, indexEntry, NODE_ENV, isProd, isDev, mode, entry, devtoolModuleFilenameTemplate, defaultOutput, staticDir, output, ManifestPluginOption, plugins, watch, postLoaders, optimization, babelOptions, moduleRulesConfig, moduleConfig, performanceConfig, resolveConfig, resolveLoaderConfig;
        return __generator(this, function (_d) {
            result = {};
            config = Object.assign({}, options);
            root = path_1.default.join(config.root, config.src);
            alias = Object.assign({}, config.alias, {
                '@routes': root,
            });
            indexEntry = isServer ? root : path_1.default.join(__dirname, '../entry/client');
            NODE_ENV = process.env.NODE_ENV;
            isProd = NODE_ENV === 'production';
            isDev = NODE_ENV === 'development';
            mode = NODE_ENV === 'test' ? 'development' : NODE_ENV || 'production';
            entry = Object.assign({}, config.entry, {
                index: [
                    !!config.hot && !isServer && 'webpack-hot-middleware/client',
                    indexEntry,
                ].filter(Boolean),
            });
            devtoolModuleFilenameTemplate = function (info) { return path_1.default.relative(root, info.absoluteResourcePath).replace(/\\/g, '/'); };
            defaultOutput = {
                // Add /* filename */ comments to generated require()s in the output.
                pathinfo: !isProd,
                // Point sourcemap entries to original disk location (format as URL on Windows)
                devtoolModuleFilenameTemplate: devtoolModuleFilenameTemplate,
                // Link the env to dom
                globalObject: 'this',
            };
            staticDir = path_1.default.join(config.root, config.publish, config.static);
            if (isServer) {
                result.target = 'node';
                defaultOutput = __assign(__assign({}, defaultOutput), { libraryTarget: 'commonjs2', path: path_1.default.join(config.root, config.publish), filename: config.serverBundleName, chunkFilename: "js/[name].js" });
            }
            else {
                defaultOutput = __assign(__assign({}, defaultOutput), { path: staticDir, filename: "js/[name].js", chunkFilename: "js/[name].js" });
            }
            output = Object.assign(defaultOutput, config.output);
            ManifestPluginOption = {
                fileName: config.assetsPath,
                generate: function (_seed, files, _entries) {
                    var assets = {};
                    for (var _i = 0, files_1 = files; _i < files_1.length; _i++) {
                        var file = files_1[_i];
                        if (!file.name) {
                            continue;
                        }
                        assets[file.name] = file.path;
                        // 生成一个不带后缀的文件名
                        // assets.vendor 可以访问到 vendor.js
                        // assets.index 可以访问到 index.js
                        if (file.name && /\.js$/.test(file.name)) {
                            assets[file.name.slice(0, -3)] = file.path;
                        }
                    }
                    return assets;
                }
            };
            plugins = [
                !isServer && new webpack_manifest_plugin_1.default(ManifestPluginOption),
                // Moment.js is an extremely popular library that bundles large locale files
                // by default due to how Webpack interprets its code. This is a practical
                // solution that requires the user to opt into importing specific locales.
                // https://github.com/jmblog/how-to-optimize-momentjs-with-webpack
                // You can remove this if you don't use Moment.js:
                !isServer && new webpack_1.default.IgnorePlugin(/^\.\/locale$/, /moment$/),
                new webpack_1.default.DefinePlugin({
                    'process.env.NODE_ENV': JSON.stringify(NODE_ENV),
                }),
                // TypeScript type checking
                config.useTypeCheck &&
                    new fork_ts_checker_webpack_plugin_1.default({
                        typescript: resolve_1.default.sync('typescript', {
                            basedir: path_1.default.join(config.root, 'node_modules'),
                        }),
                        async: !isProd,
                        useTypescriptIncrementalApi: true,
                        checkSyntacticErrors: true,
                        tsconfig: path_1.default.join(config.root, 'tsconfig.json'),
                        reportFiles: [
                            '**',
                            '!**/*.json',
                            '!**/__tests__/**',
                            '!**/?(*.)(spec|test).*',
                            '!**/src/setupProxy.*',
                            '!**/src/setupTests.*',
                        ],
                        watch: config.root,
                    }),
            ].filter(Boolean);
            // 添加热更新插件
            if (isDev && !isServer && config.hot) {
                plugins.push(new webpack_1.default.HotModuleReplacementPlugin());
            }
            if (Array.isArray(config.webpackPlugins)) {
                plugins = plugins.concat(config.webpackPlugins);
            }
            watch = NODE_ENV !== 'test';
            postLoaders = [];
            optimization = {
                // Automatically split vendor and commons
                // https://twitter.com/wSokra/status/969633336732905474
                // https://medium.com/webpack/webpack-4-code-splitting-chunk-graph-and-the-splitchunks-optimization-be739a861366
                splitChunks: {
                    chunks: 'all',
                    name: 'vendor',
                },
            };
            if (isProd) {
                watch = false;
                if (!isServer) {
                    output = Object.assign(defaultOutput, !isServer && {
                        filename: 'js/[name]-[contenthash:10].js',
                        chunkFilename: 'js/[name]-[contenthash:10].js',
                        devtoolModuleFilenameTemplate: devtoolModuleFilenameTemplate,
                    }, config.productionOutput);
                    Object.assign(optimization, {
                        minimizer: [
                            new terser_webpack_plugin_1.default({
                                terserOptions: {
                                    parse: {
                                        // we want terser to parse ecma 8 code. However, we don't want it
                                        // to apply any minfication steps that turns valid ecma 5 code
                                        // into invalid ecma 5 code. This is why the 'compress' and 'output'
                                        // sections only apply transformations that are ecma 5 safe
                                        // https://github.com/facebook/create-react-app/pull/4234
                                        ecma: 8,
                                    },
                                    compress: {
                                        // ecma: 5, // 默认为5，但目前ts似乎不支持该参数
                                        drop_console: true,
                                        warnings: false,
                                        // Disabled because of an issue with Uglify breaking seemingly valid code:
                                        // https://github.com/facebook/create-react-app/issues/2376
                                        // Pending further investigation:
                                        // https://github.com/mishoo/UglifyJS2/issues/2011
                                        comparisons: false,
                                        // Disabled because of an issue with Terser breaking valid code:
                                        // https://github.com/facebook/create-react-app/issues/5250
                                        // Pending futher investigation:
                                        // https://github.com/terser-js/terser/issues/120
                                        inline: 2,
                                    },
                                    mangle: {
                                        safari10: true,
                                    },
                                    output: {
                                        ecma: 5,
                                        comments: false,
                                        // Turned on because emoji and regex is not minified properly using default
                                        // https://github.com/facebook/create-react-app/issues/2488
                                        ascii_only: true,
                                    },
                                },
                                // Use multi-process parallel running to improve the build speed
                                // Default number of concurrent runs: os.cpus().length - 1
                                parallel: true,
                                // Enable file caching
                                cache: true,
                                sourceMap: false,
                            }),
                        ],
                    });
                }
                else {
                    optimization = {
                        minimize: false,
                    };
                }
            }
            if (!isServer && config.bundleAnalyzer) {
                plugins = plugins.concat([
                    new webpack_bundle_analyzer_1.BundleAnalyzerPlugin(Object.assign({
                        // Automatically open analyzer page in default browser
                        openAnalyzer: true,
                        // Analyzer HTTP-server port
                        analyzerPort: 8090,
                    }, config.bundleAnalyzer)),
                ]);
            }
            babelOptions = __assign(__assign({ 
                // include presets|plugins
                babelrc: false, configFile: false, cacheDirectory: true }, config.babel(config)), { 
                // Save disk space when time isn't as important
                cacheCompression: isProd, compact: isProd });
            moduleRulesConfig = [
                // Disable require.ensure as it's not a standard language feature.
                { parser: { requireEnsure: false } },
                // Process application JS with Babel.
                // The preset includes JSX, Flow, TypeScript and some ESnext features.
                {
                    test: /\.(js|mjs|jsx|ts|tsx)$/,
                    exclude: /(node_modules|bower_components)/,
                    loader: 'babel-loader',
                    options: babelOptions,
                },
            ];
            // 将指定的node_modules目录下的文件也进行babel编译
            if ((_a = config.compileNodeModules) === null || _a === void 0 ? void 0 : _a.rules) {
                moduleRulesConfig = moduleRulesConfig.concat({
                    test: /\.(js|mjs|jsx|ts|tsx)$/,
                    include: function (filename) {
                        var _a;
                        if (!filename.includes('node_modules')) {
                            return false;
                        }
                        return (0, compileNodeModules_1.checkFilename)(filename, (_a = config.compileNodeModules) === null || _a === void 0 ? void 0 : _a.rules);
                    },
                    loader: 'babel-loader',
                    options: babelOptions,
                });
            }
            if (config.useFileLoader) {
                moduleRulesConfig = moduleRulesConfig.concat({
                    test: /\.(png|jpe?g|gif|css)$/i,
                    loader: 'file-loader',
                    options: {
                        name: isProd ? '[name]-[contenthash:10].[ext]' : '[name].[ext]',
                        emitFile: !isServer,
                        outputPath: function (url, resourcePath, context) {
                            var outputFilename = path_1.default.basename(url);
                            var outputPath = resourcePath.replace(context + path_1.default.sep, '');
                            var outputDirname = path_1.default.dirname(outputPath);
                            return path_1.default.join(outputDirname, outputFilename).replaceAll(path_1.default.sep, '/');
                        },
                        publicPath: function (url, resourcePath, context) {
                            var outputFilename = path_1.default.basename(url);
                            var outputPath = resourcePath.replace(context, '');
                            var outputDirname = path_1.default.dirname(outputPath);
                            return path_1.default.join(outputDirname, outputFilename).replaceAll(path_1.default.sep, '/');
                        }
                    },
                });
            }
            moduleRulesConfig = moduleRulesConfig.concat(config.webpackLoaders, postLoaders);
            moduleConfig = {
                // makes missing exports an error instead of warning
                strictExportPresence: true,
                rules: moduleRulesConfig,
            };
            performanceConfig = __assign({ hints: false, maxEntrypointSize: 400000 }, config.performance);
            resolveConfig = {
                modules: ['node_modules'],
                extensions: ['.js', '.jsx', '.json', '.mjs', '.ts', '.tsx'],
                alias: alias,
                plugins: [
                    // Adds support for installing with Plug'n'Play, leading to faster installs and adding
                    // guards against forgotten dependencies and such.
                    pnp_webpack_plugin_1.default,
                ],
            };
            resolveLoaderConfig = {
                plugins: [
                    // Also related to Plug'n'Play, but this time it tells Webpack to load its loaders
                    // from the current package.
                    pnp_webpack_plugin_1.default.moduleLoader(module),
                ],
            };
            result = Object.assign(result, {
                target: isServer ? 'node' : 'web',
                mode: mode,
                // Don't attempt to continue if there are any errors.
                bail: true,
                watch: watch,
                devtool: isServer ? 'source-map' : config.devtool,
                entry: entry,
                output: output,
                module: moduleConfig,
                plugins: plugins,
                optimization: optimization,
                performance: performanceConfig,
                resolve: resolveConfig,
                context: root,
                resolveLoader: resolveLoaderConfig,
                externals: isServer ? (0, webpack_node_externals_1.default)({
                    allowlist: ((_c = (_b = config.compileNodeModules) === null || _b === void 0 ? void 0 : _b.rules) !== null && _c !== void 0 ? _c : []),
                    modulesFromFile: true,
                }) : void 0,
            });
            if (!!config.webpack) {
                result = config.webpack(result, isServer);
            }
            return [2 /*return*/, result];
        });
    });
}
exports.default = createWebpackConfig;
