"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var del_1 = __importDefault(require("del"));
var gulp_1 = __importDefault(require("gulp"));
var path_1 = __importDefault(require("path"));
var webpack_1 = __importDefault(require("webpack"));
var start_1 = __importDefault(require("../start"));
var config_1 = __importDefault(require("../config"));
var createGulpTask_1 = __importDefault(require("./createGulpTask"));
var createWebpackConfig_1 = __importDefault(require("./createWebpackConfig"));
require("core-js/stable");
require("regenerator-runtime/runtime");
var assetsHelper_1 = require("./assetsHelper");
function build(options) {
    var _this = this;
    var config = (0, config_1.default)(options, true);
    var delPublicPgs = function () { return delPublish(path_1.default.join(config.root, config.publish)); };
    var startGulpPgs = function () { return startGulp(config); };
    var startWebpackPgs = function () { return __awaiter(_this, void 0, void 0, function () {
        var publishPath, staticPath, gulpAssets, assetsPath, webpackAssets, mergedAssets;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    publishPath = path_1.default.join(config.root, config.publish);
                    staticPath = path_1.default.join(publishPath, config.static);
                    gulpAssets = null;
                    if (!config.useContentHash) return [3 /*break*/, 2];
                    return [4 /*yield*/, (0, assetsHelper_1.revStaticAssets)(staticPath)];
                case 1:
                    gulpAssets = _a.sent();
                    _a.label = 2;
                case 2: return [4 /*yield*/, Promise.all([
                        startWebpackForClient(config),
                        startWebpackForServer(config),
                    ])];
                case 3:
                    _a.sent();
                    if (!gulpAssets) {
                        return [2 /*return*/];
                    }
                    assetsPath = path_1.default.join(staticPath, config.assetsPath);
                    webpackAssets = require(assetsPath);
                    mergedAssets = __assign(__assign({}, gulpAssets), webpackAssets);
                    return [4 /*yield*/, (0, assetsHelper_1.replaceManifestInDir)(publishPath, gulpAssets)];
                case 4:
                    _a.sent();
                    fs_1.default.writeFileSync(assetsPath, JSON.stringify(mergedAssets, null, 2));
                    return [2 /*return*/];
            }
        });
    }); };
    var startStaticEntryPgs = function () { return startStaticEntry(config); };
    var errorHandler = function (error) {
        console.error(error);
        process.exit(1);
    };
    var finalHandler = function () {
        console.log('build successfully!');
        process.exit(0);
    };
    return Promise.resolve()
        .then(delPublicPgs)
        .then(startGulpPgs)
        .then(startWebpackPgs)
        .then(startStaticEntryPgs)
        .catch(errorHandler)
        .finally(finalHandler);
}
exports.default = build;
function delPublish(folder) {
    console.log("delete publish folder: ".concat(folder));
    return (0, del_1.default)(folder);
}
function startWebpackForClient(config) {
    return __awaiter(this, void 0, void 0, function () {
        var webpackConfig;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, (0, createWebpackConfig_1.default)(config, false)];
                case 1:
                    webpackConfig = _a.sent();
                    return [2 /*return*/, new Promise(function (resolve, reject) {
                            (0, webpack_1.default)(webpackConfig, function (error, stats) {
                                if (error) {
                                    reject(error);
                                }
                                else {
                                    if (config.webpackLogger) {
                                        console.log('[webpack:client:build]', stats.toString(config.webpackLogger));
                                    }
                                    resolve();
                                }
                            });
                        })];
            }
        });
    });
}
function startWebpackForServer(config) {
    return __awaiter(this, void 0, void 0, function () {
        var webpackConfig;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, (0, createWebpackConfig_1.default)(config, true)];
                case 1:
                    webpackConfig = _a.sent();
                    return [2 /*return*/, new Promise(function (resolve, reject) {
                            (0, webpack_1.default)(webpackConfig, function (error, stats) {
                                if (error) {
                                    reject(error);
                                }
                                else {
                                    if (config.webpackLogger) {
                                        console.log('[webpack:server:build]', stats.toString(config.webpackLogger));
                                    }
                                    resolve();
                                }
                            });
                        })];
            }
        });
    });
}
function startGulp(config) {
    return new Promise(function (resolve, reject) {
        gulp_1.default.task('default', (0, createGulpTask_1.default)(config));
        gulp_1.default.series('default')(function (error) {
            if (error) {
                reject(error);
            }
            else {
                resolve();
            }
        });
    });
}
function startStaticEntry(config) {
    return __awaiter(this, void 0, void 0, function () {
        var appSettings, staticEntryConfig, server, url, response, html, staticEntryPath;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!config.staticEntry) {
                        return [2 /*return*/];
                    }
                    console.log("start generating static entry file");
                    appSettings = __assign(__assign({}, config.appSettings), { type: 'createHashHistory' });
                    staticEntryConfig = __assign(__assign({}, config), { root: path_1.default.join(config.root, config.publish), 
                        // 默认当前文件夹
                        publicPath: config.publicPath || '.', appSettings: appSettings, SSR: false });
                    return [4 /*yield*/, (0, start_1.default)({
                            config: staticEntryConfig,
                        })];
                case 1:
                    server = (_a.sent()).server;
                    url = "http://localhost:".concat(config.port, "/__CREATE_STATIC_ENTRY__");
                    console.log("fetching url:".concat(url));
                    return [4 /*yield*/, fetch(url)];
                case 2:
                    response = _a.sent();
                    return [4 /*yield*/, response.text()];
                case 3:
                    html = _a.sent();
                    staticEntryPath = path_1.default.join(config.root, config.publish, config.static, config.staticEntry);
                    server.close(function () { return console.log('finish generating static entry file'); });
                    return [2 /*return*/, new Promise(function (resolve, reject) {
                            var callback = function (error) {
                                error ? reject(error) : resolve();
                            };
                            fs_1.default.writeFile(staticEntryPath, html, callback);
                        })];
            }
        });
    });
}
