"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.reporter = exports.setupServer = exports.setupClient = void 0;
var vm_1 = __importDefault(require("vm"));
var path_1 = __importDefault(require("path"));
var memory_fs_1 = __importDefault(require("memory-fs"));
var webpack_1 = __importDefault(require("webpack"));
var node_notifier_1 = __importDefault(require("node-notifier"));
var webpack_dev_middleware_1 = __importDefault(require("webpack-dev-middleware"));
var createWebpackConfig_1 = __importDefault(require("./createWebpackConfig"));
function setupClient(config) {
    return __awaiter(this, void 0, void 0, function () {
        var startTime, clientConfig, compiler;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    startTime = Date.now();
                    console.log('client webpack is starting...');
                    return [4 /*yield*/, (0, createWebpackConfig_1.default)(config)];
                case 1:
                    clientConfig = _a.sent();
                    compiler = (0, webpack_1.default)(clientConfig);
                    return [2 /*return*/, new Promise(function (resolve) {
                            var isResolved = false;
                            var middleware = (0, webpack_dev_middleware_1.default)(compiler, {
                                publicPath: config.staticPath,
                                stats: config.webpackLogger,
                                serverSideRender: true,
                                reporter: function (middlewareOptions, options) {
                                    reporter(middlewareOptions, options);
                                    if (config.notifier) {
                                        node_notifier_1.default.notify({
                                            title: 'React-IMVC',
                                            message: 'Webpack 编译结束',
                                        });
                                    }
                                    if (!isResolved) {
                                        isResolved = true;
                                        console.log("client webpack compile success in ".concat(Date.now() - startTime, "ms"));
                                        resolve({
                                            middleware: middleware,
                                            compiler: compiler,
                                        });
                                    }
                                },
                            });
                        })];
            }
        });
    });
}
exports.setupClient = setupClient;
function setupServer(config, options) {
    var _a;
    return __awaiter(this, void 0, void 0, function () {
        var startTime, serverConfig, serverCompiler, mfs, outputDir, outputPath;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    startTime = Date.now();
                    console.log('server webpack is starting...');
                    return [4 /*yield*/, (0, createWebpackConfig_1.default)(config, true)];
                case 1:
                    serverConfig = _b.sent();
                    if (!((_a = serverConfig.output) === null || _a === void 0 ? void 0 : _a.path) || !serverConfig.output.filename) {
                        throw new Error('serverConfig.output.path and serverConfig.output.filename must be specified');
                    }
                    serverCompiler = (0, webpack_1.default)(serverConfig);
                    mfs = new memory_fs_1.default();
                    outputDir = serverConfig.output.path;
                    outputPath = path_1.default.join(outputDir, serverConfig.output.filename);
                    serverCompiler.outputFileSystem = mfs;
                    return [2 /*return*/, new Promise(function (resolve, reject) {
                            var isResolved = false;
                            serverCompiler.watch({}, function (err, stats) {
                                if (err)
                                    throw err;
                                var currentStats = stats.toJson();
                                currentStats.errors.forEach(function (err) { return console.error(err); });
                                currentStats.warnings.forEach(function (err) { return console.warn(err); });
                                var sourceCode = mfs.readFileSync(outputPath, 'utf-8');
                                var virtualRequire = function (modulePath) {
                                    var filePath = path_1.default.join(outputDir, modulePath);
                                    if (mfs.existsSync(filePath)) {
                                        var sourceCode_1 = mfs.readFileSync(filePath, 'utf-8');
                                        return runCode(sourceCode_1);
                                    }
                                    return require(modulePath);
                                };
                                var runCode = function (sourceCode) {
                                    return vm_1.default.runInThisContext("\n          (function(require) {\n            var module = {exports: {}}\n                    var factory = function(require, module, exports) {\n                        ".concat(sourceCode, "\n                    }\n\n                    factory(require, module, module.exports)\n\n                    return module.exports\n          })\n        "))(virtualRequire);
                                };
                                try {
                                    // 构造一个 commonjs 的模块加载函数，拿到 newModule
                                    var newModule = runCode(sourceCode);
                                    if (!isResolved) {
                                        isResolved = true;
                                        console.log("server webpack compile success in ".concat(Date.now() - startTime, "ms"));
                                        resolve((newModule === null || newModule === void 0 ? void 0 : newModule.default) || newModule);
                                    }
                                    else {
                                        options.handleHotModule((newModule === null || newModule === void 0 ? void 0 : newModule.default) || newModule);
                                    }
                                }
                                catch (error) {
                                    reject(error);
                                }
                            });
                        })];
            }
        });
    });
}
exports.setupServer = setupServer;
function reporter(middlewareOptions, options) {
    var log = options.log, state = options.state, stats = options.stats;
    if (state) {
        var displayStats = middlewareOptions.stats !== false;
        var statsString = stats ? stats.toString(middlewareOptions.stats) : '';
        if (displayStats && statsString.trim().length) {
            if (stats && stats.hasErrors()) {
                log.error(statsString);
            }
            else if (stats && stats.hasWarnings()) {
                log.warn(statsString);
            }
            else {
                log.info(statsString);
            }
        }
        var message = 'Compiled successfully.';
        if (stats && stats.hasErrors()) {
            message = 'Failed to compile.';
        }
        else if (stats && stats.hasWarnings()) {
            message = 'Compiled with warnings.';
        }
        log.info(message);
    }
    else {
        log.info('Compiling...');
    }
}
exports.reporter = reporter;
