"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.matchExternals = exports.getExternals = exports.getPackageRelativePath = void 0;
var path_1 = __importDefault(require("path"));
var fs_1 = __importDefault(require("fs"));
require("webpack-node-externals");
// @ts-ignore
var utils_1 = require("webpack-node-externals/utils");
function getPackageRelativePath(config) {
    var cwd = process.cwd();
    if (typeof config.root !== 'string' || config.root === cwd) {
        return 'package.json';
    }
    var rootPackagePath = path_1.default.join(config.root, './package.json');
    var rootParentPackagePath = path_1.default.join(config.root, '../package.json');
    if (fs_1.default.existsSync(rootPackagePath)) {
        return path_1.default.relative(cwd, rootPackagePath);
    }
    else if (fs_1.default.existsSync(rootParentPackagePath)) {
        return path_1.default.relative(cwd, rootParentPackagePath);
    }
    return 'package.json';
}
exports.getPackageRelativePath = getPackageRelativePath;
function getExternals(config) {
    return (0, utils_1.readFromPackageJson)({ fileName: getPackageRelativePath(config) });
}
exports.getExternals = getExternals;
function matchExternals(externals, modulePath) {
    for (var i = 0; i < externals.length; i++) {
        if (modulePath.startsWith(externals[i])) {
            return true;
        }
    }
    return false;
}
exports.matchExternals = matchExternals;
