import React from 'react';
import Controller from '../controller';
import type { Actions } from 'relite';
import type { BaseState } from '..';
export interface ControllerProxyProps<S extends object, AS extends Actions<S & BaseState>> {
    controller: Controller<S, AS>;
}
/**
 * ViewProxy 把 react 组件生命周期同步到 controller 里
 * 根据 state 更新 document.title
 */
export default class ControllerProxy<S extends object, AS extends Actions<S & BaseState>> extends React.Component<ControllerProxyProps<S, AS>> {
    static ignoreErrors: boolean;
    updateDocumentTitle(): void;
    emit(method: string): Promise<void>;
    componentDidMount(): void;
    componentWillUnmount(): void;
    componentDidUpdate(): void;
    render(): null;
}
