import React from 'react';
import type { BaseState } from '..';
export interface ErrorBoundaryProps {
    fallback: object | string | null;
}
export default class ErrorBoundary extends React.Component<ErrorBoundaryProps, Partial<BaseState>> {
    static ignoreErrors: boolean;
    static contextType: React.Context<{
        ctrl: import("../controller").default<any, any>;
        location: import("create-app/lib").HistoryLocation;
        history: import("create-history").HistoryWithBFOL<import("create-history").BLWithBQ, import("create-history").ILWithBQ>;
        state: any;
        actions: import("relite").Currings<any, any>;
        preload: import("..").Preload | undefined;
        matcher: import("create-app/lib").Matcher;
        loader: import("create-app/lib").Loader;
        prefetch: (url: string) => import("create-app/lib").ControllerConstructor<import("create-app/lib").Controller> | Promise<import("create-app/lib").ControllerConstructor<import("create-app/lib").Controller>> | null;
    }>;
    static getDerivedStateFromError(): {
        hasError: boolean;
    };
    static defaultProps: ErrorBoundaryProps;
    state: Readonly<Partial<BaseState>>;
    catchError(error: Error): void;
    componentDidCatch(error: Error): void;
    render(): React.ReactNode;
}
export declare const withFallback: (fallback: object) => (InputComponent: React.ComponentType) => {
    (props: object): any;
    name: string;
};
