"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.withFallback = void 0;
var react_1 = __importDefault(require("react"));
var context_1 = __importDefault(require("../context"));
// fixed: webpack rebuild lost original React.createElement
// @ts-ignore
var createElement = react_1.default.originalCreateElement || react_1.default.createElement;
var ErrorBoundary = /** @class */ (function (_super) {
    __extends(ErrorBoundary, _super);
    function ErrorBoundary() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            hasError: false,
        };
        return _this;
    }
    ErrorBoundary.getDerivedStateFromError = function () {
        return { hasError: true };
    };
    ErrorBoundary.prototype.catchError = function (error) {
        var ctrl = this.context.ctrl;
        if (ctrl.errorDidCatch) {
            ctrl.errorDidCatch(error, 'view');
        }
    };
    ErrorBoundary.prototype.componentDidCatch = function (error) {
        this.catchError(error);
    };
    ErrorBoundary.prototype.render = function () {
        if (this.state.hasError) {
            return this.props.fallback;
        }
        var prevCreateElement = react_1.default.createElement;
        react_1.default.createElement = createElement;
        try {
            return this.props.children;
        }
        catch (error) {
            this.catchError(error);
            return this.props.fallback;
        }
        finally {
            react_1.default.createElement = prevCreateElement;
        }
    };
    ErrorBoundary.ignoreErrors = true;
    ErrorBoundary.contextType = context_1.default;
    ErrorBoundary.defaultProps = {
        fallback: null,
    };
    return ErrorBoundary;
}(react_1.default.Component));
exports.default = ErrorBoundary;
var withFallback = function (fallback) { return function (InputComponent) {
    function Component(props) {
        return createElement(ErrorBoundary, { fallback: fallback }, function () {
            return createElement(InputComponent, props);
        });
    }
    var displayName = InputComponent.name || InputComponent.displayName;
    Component.name = "ErrorBoundary(".concat(displayName, ")");
    return Component;
}; };
exports.withFallback = withFallback;
