import React from 'react';
export interface Transformer {
    <T>(currentValue?: T, oldValue?: T): T;
}
export interface InputProps {
    as?: keyof HTMLElementTagNameMap;
    type?: string;
    name: string;
    actionType?: string;
    value?: string;
    check?: ((value: string) => boolean) | boolean;
    transformer?: Transformer;
    [propName: string]: any;
}
export default class Input extends React.Component<InputProps> {
    static contextType: React.Context<{
        ctrl: import("../controller").default<any, any>;
        location: import("create-app/lib").HistoryLocation;
        history: import("create-history").HistoryWithBFOL<import("create-history").BLWithBQ, import("create-history").ILWithBQ>;
        state: any;
        actions: import("relite").Currings<any, any>;
        preload: import("..").Preload | undefined;
        matcher: import("create-app/lib").Matcher;
        loader: import("create-app/lib").Loader;
        prefetch: (url: string) => import("create-app/lib").ControllerConstructor<import("create-app/lib").Controller> | Promise<import("create-app/lib").ControllerConstructor<import("create-app/lib").Controller>> | null;
    }>;
    static defaultProps: {
        as: string;
        type: string;
        name: string;
        actionType: string;
    };
    render(): React.DetailedReactHTMLElement<Record<string, any>, HTMLElement>;
    handleChange: (event: React.ChangeEvent<HTMLInputElement>) => void;
    handleFocus: (event: React.FocusEvent<HTMLInputElement>) => void;
    handleBlur: (event: React.FocusEvent<HTMLInputElement>) => void;
}
