"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var context_1 = __importDefault(require("../context"));
var util_1 = require("../util");
var Input = /** @class */ (function (_super) {
    __extends(Input, _super);
    function Input() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleChange = function (event) {
            var _a;
            var _b = _this.context, state = _b.state, handleInputChange = _b.handleInputChange;
            var _c = _this.props, name = _c.name, onChange = _c.onChange, check = _c.check, transformer = _c.transformer;
            var currentValue = event.currentTarget.value;
            var path = check ? "".concat(name, ".value") : name;
            var oldValue = (0, util_1.getValueByPath)(state, path);
            if (typeof transformer === 'function') {
                currentValue = transformer(currentValue, oldValue);
            }
            if (handleInputChange) {
                currentValue = handleInputChange(path, currentValue, oldValue);
            }
            _this.context.actions[_this.props.actionType || Input.defaultProps.actionType]((_a = {},
                _a[path] = currentValue,
                _a));
            onChange && onChange(event);
        };
        _this.handleFocus = function (event) {
            var _a;
            var state = _this.context.state;
            var _b = _this.props, name = _b.name, onFocus = _b.onFocus;
            var path = "".concat(name, ".isWarn");
            var isWarn = (0, util_1.getValueByPath)(state, path);
            if (!isWarn) {
                onFocus && onFocus(event);
                return;
            }
            _this.context.actions[_this.props.actionType || Input.defaultProps.actionType]((_a = {},
                _a[path] = false,
                _a));
            onFocus && onFocus(event);
        };
        _this.handleBlur = function (event) {
            var _a;
            var _b = _this.props, name = _b.name, onBlur = _b.onBlur, check = _b.check;
            var pathOfValidState = "".concat(name, ".isValid");
            var pathOfWarnState = "".concat(name, ".isWarn");
            var isValidValue = check(event.currentTarget.value);
            _this.context.actions[_this.props.actionType || Input.defaultProps.actionType]((_a = {},
                _a[pathOfValidState] = isValidValue,
                _a[pathOfWarnState] = !isValidValue,
                _a));
            onBlur && onBlur(event);
        };
        return _this;
    }
    Input.prototype.render = function () {
        var state = this.context.state;
        var _a = this.props, tag = _a.as, name = _a.name, value = _a.value, check = _a.check, actionType = _a.actionType, transformer = _a.transformer, restSubProps = __rest(_a, ["as", "name", "value", "check", "actionType", "transformer"]);
        var subProps = restSubProps;
        var path = check ? "".concat(name, ".value") : name;
        if (value === void 0) {
            value = (0, util_1.getValueByPath)(state, path);
        }
        subProps.value = value;
        subProps.name = name;
        subProps.onChange = this.handleChange;
        if (check) {
            subProps.onFocus = this.handleFocus;
            subProps.onBlur = this.handleBlur;
        }
        return react_1.default.createElement(tag ? tag : 'input', subProps);
    };
    Input.contextType = context_1.default;
    Input.defaultProps = {
        as: 'input',
        type: 'text',
        name: '',
        actionType: 'UPDATE_INPUT_VALUE',
    };
    return Input;
}(react_1.default.Component));
exports.default = Input;
