"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var context_1 = __importDefault(require("../context"));
var Link = /** @class */ (function (_super) {
    __extends(Link, _super);
    function Link() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleClick = function (event) {
            var _a = _this.props, onClick = _a.onClick, replace = _a.replace, back = _a.back, forward = _a.forward, go = _a.go, to = _a.to;
            var history = _this.context.history;
            onClick && onClick(event);
            if (event.defaultPrevented || // onClick prevented default
                event.button !== 0 || // ignore everything but left clicks
                _this.props.target || // let browser handle "target=_blank" etc.
                isModifiedEvent(event) // ignore clicks with modifier keys
            ) {
                return;
            }
            if (back) {
                history.goBack();
            }
            else if (forward) {
                history.goForward();
            }
            else if (go) {
                history.go(go);
            }
            else if (to) {
                event.preventDefault();
                if (replace === true) {
                    history.replace(to);
                }
                else {
                    history.push(to);
                }
            }
        };
        return _this;
    }
    Link.prototype.componentDidMount = function () {
        if (this.props.prefetch) {
            this.context.prefetch(this.props.to || this.props.href);
        }
    };
    Link.prototype.render = function () {
        var _a = this.context.state.basename, basename = _a === void 0 ? '' : _a;
        var _b = this.props, to = _b.to, href = _b.href, children = _b.children, replace = _b.replace, back = _b.back, forward = _b.forward, go = _b.go, tag = _b.as, prefetch = _b.prefetch, others = __rest(_b, ["to", "href", "children", "replace", "back", "forward", "go", "as", "prefetch"]);
        if (tag === 'a') {
            var targetPath = to ? "".concat(basename).concat(to) : null;
            if (!targetPath && href) {
                targetPath = href;
            }
            return (react_1.default.createElement("a", __assign({}, others, { href: targetPath, onClick: this.handleClick }), children));
        }
        return react_1.default.createElement(tag, Object.assign({}, others, { onClick: this.handleClick }), children);
    };
    Link.contextType = context_1.default;
    Link.defaultProps = {
        as: 'a',
    };
    return Link;
}(react_1.default.Component));
exports.default = Link;
function isModifiedEvent(event) {
    return !!(event.metaKey || event.altKey || event.ctrlKey || event.shiftKey);
}
