"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var react_dom_1 = require("react-dom");
var OuterClickWrapper = /** @class */ (function (_super) {
    __extends(OuterClickWrapper, _super);
    function OuterClickWrapper() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleOutterClick = function (event) {
            var onClick = _this.props.onClick;
            if (!onClick) {
                return;
            }
            var root = (0, react_dom_1.findDOMNode)(_this);
            var isContains = _this.contains(root, (event.target || event.srcElement));
            if (!isContains) {
                onClick(event);
            }
        };
        return _this;
    }
    OuterClickWrapper.prototype.componentDidMount = function () {
        if (document.addEventListener) {
            document.addEventListener('click', this.handleOutterClick);
        }
        else if (document.attachEvent) {
            document.attachEvent('onclick', this.handleOutterClick);
        }
    };
    OuterClickWrapper.prototype.componentWillUnmount = function () {
        if (document.removeEventListener) {
            document.removeEventListener('click', this.handleOutterClick);
        }
        else if (document.detachEvent) {
            document.detachEvent('onclick', this.handleOutterClick);
        }
    };
    // 结点是否包含结点
    OuterClickWrapper.prototype.contains = function (rootNode, node) {
        if (rootNode && typeof rootNode.contains === 'function') {
            return rootNode.contains(node);
        }
        while (node) {
            if (node === rootNode) {
                return true;
            }
            node = node.parentNode;
        }
        return false;
    };
    OuterClickWrapper.prototype.render = function () {
        return react_1.Children.only(this.props.children);
    };
    return OuterClickWrapper;
}(react_1.Component));
exports.default = OuterClickWrapper;
