"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
require("core-js/stable");
require("regenerator-runtime/runtime");
require("../polyfill");
var react_1 = __importDefault(require("react"));
var react_dom_1 = __importDefault(require("react-dom"));
var client_1 = __importDefault(require("create-app/client"));
var util_1 = require("../util");
__webpack_public_path__ = window.__PUBLIC_PATH__ + '/';
var __APP_SETTINGS__ = window.__APP_SETTINGS__;
function getModule(module) {
    return module.default || module;
}
function isIMVCController(fn) {
    return fn.__SYMBOL === 'REACT_IMVC_CONTROLLER';
}
function isThenable(input) {
    // @ts-ignore
    return input && input.then && typeof input.then === 'function';
}
function webpackLoader(controller, location, context) {
    var ctrl = null;
    if (isIMVCController(controller) || isThenable(controller)) {
        ctrl = controller;
    }
    else {
        ctrl = controller(location, context);
    }
    if (isThenable(ctrl)) {
        return ctrl.then(getModule);
    }
    else {
        return getModule(ctrl);
    }
}
var shouldHydrate = !!window.__INITIAL_STATE__;
function render(view, controller, container) {
    if (!view)
        return;
    if (typeof view === 'string') {
        view = react_1.default.createElement(react_1.default.Fragment, null, view);
    }
    try {
        if (container) {
            if (shouldHydrate) {
                shouldHydrate = false;
                react_dom_1.default.hydrate(view, container);
            }
            else {
                react_dom_1.default.render(view, container);
            }
        }
    }
    catch (error) {
        if (!controller)
            throw error;
        if (controller.errorDidCatch) {
            controller.errorDidCatch(error, 'view');
        }
        if (controller.getViewFallback) {
            render(controller.getViewFallback(), null, container);
        }
        else {
            throw error;
        }
    }
}
var viewEngine = { render: render };
var $routes = require('@routes');
var routes = (0, util_1.getFlatList)(Array.isArray($routes) ? $routes : Object.values($routes));
var appSettings = __assign(__assign({ hashType: 'hashbang', container: '#root' }, __APP_SETTINGS__), { context: __assign(__assign({ preload: {} }, __APP_SETTINGS__.context), { isClient: true, isServer: false }), loader: webpackLoader, routes: routes, viewEngine: viewEngine });
/**
 * 动态收集服务端预加载的内容
 */
var preload = {};
Array.from(document.querySelectorAll('[data-preload]')).forEach(function (elem) {
    var name = elem.getAttribute('data-preload');
    var content = elem.textContent || elem.innerHTML;
    if (name) {
        preload[name] = content;
    }
});
if (typeof appSettings.context !== 'undefined') {
    appSettings.context.preload = preload;
}
var app = (0, client_1.default)(appSettings);
app.start();
// 热更新
if (typeof module !== 'undefined' && module.hot) {
    if (module.hot) {
        var hot = module.hot;
        if (hot && hot.accept) {
            hot.accept();
        }
    }
}
