"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var morgan_1 = __importDefault(require("morgan"));
var helmet_1 = __importDefault(require("helmet"));
var express_1 = __importDefault(require("express"));
var serve_favicon_1 = __importDefault(require("serve-favicon"));
var body_parser_1 = __importDefault(require("body-parser"));
var compression_1 = __importDefault(require("compression"));
var cookie_parser_1 = __importDefault(require("cookie-parser"));
var babel_1 = __importDefault(require("../config/babel"));
var shareRoot_1 = __importDefault(require("../middleware/shareRoot"));
var setupDevEnv = __importStar(require("../build/setupDevEnv"));
var assetsHelper_1 = require("../build/assetsHelper");
function createExpressApp(config) {
    return __awaiter(this, void 0, void 0, function () {
        var app, list, viewsConfig, _a, _b, secret, options, _c, compiler, middleware, webpackHotMiddleware, assets_1;
        var _this = this;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    app = (0, express_1.default)();
                    list = Array.isArray(config.basename)
                        ? config.basename
                        : [config.basename || ''];
                    list.forEach(function (basename) {
                        app.use((0, shareRoot_1.default)(basename));
                    });
                    // handle helmet
                    if (config.helmet) {
                        app.use((0, helmet_1.default)(config.helmet));
                    }
                    // handle compression
                    if (config.compression) {
                        app.use((0, compression_1.default)(config.compression));
                    }
                    // handle favicon
                    if (config.favicon) {
                        app.use((0, serve_favicon_1.default)(config.favicon));
                    }
                    viewsConfig = __assign(__assign({}, config.ReactViews), { babel: __assign(__assign({}, babel_1.default), { extensions: ['.es6', '.es', '.jsx', '.js', '.mjs', '.ts', '.tsx'] }) });
                    app.engine('js', require('express-react-views').createEngine(viewsConfig));
                    app.engine('jsx', require('express-react-views').createEngine(viewsConfig));
                    app.engine('ts', require('express-react-views').createEngine(viewsConfig));
                    app.engine('tsx', require('express-react-views').createEngine(viewsConfig));
                    // view engine setup
                    app.set('views', path_1.default.join(config.root, config.routes));
                    app.set('view engine', 'js'); // default view engine ext .js
                    // handle logger
                    if (config.logger) {
                        app.use((0, morgan_1.default)(config.logger));
                    }
                    // handle bodyParser
                    if (config.bodyParser) {
                        if (config.bodyParser.json) {
                            app.use(body_parser_1.default.json(config.bodyParser.json));
                        }
                        if (config.bodyParser.urlencoded) {
                            app.use(body_parser_1.default.urlencoded(config.bodyParser.urlencoded));
                        }
                    }
                    // handle cookieParser
                    if (config.cookieParser) {
                        _a = config.cookieParser, _b = _a.secret, secret = _b === void 0 ? 'imvc' : _b, options = __rest(_a, ["secret"]);
                        app.use((0, cookie_parser_1.default)(secret, options));
                    }
                    app.use('/mock', function (req, res, next) {
                        var filePath = path_1.default.join(config.root, config.src, "".concat(req.path, ".json"));
                        res.type('application/json');
                        fs_1.default.createReadStream(filePath).pipe(res);
                    });
                    app.get('/slbhealthcheck.html', function (req, res) {
                        res.send('slbhealthcheck ok');
                    });
                    if (!config.webpackDevMiddleware) return [3 /*break*/, 2];
                    return [4 /*yield*/, setupDevEnv.setupClient(config)];
                case 1:
                    _c = _d.sent(), compiler = _c.compiler, middleware = _c.middleware;
                    app.use(middleware);
                    // 添加热更新中间件
                    if (config.hot) {
                        webpackHotMiddleware = require("webpack-hot-middleware");
                        app.use(webpackHotMiddleware(compiler, {
                            log: false,
                            quiet: true,
                            noInfo: true,
                        }));
                    }
                    // 开发模式里，用 src 里的静态资源
                    app.use(config.staticPath, express_1.default.static(path_1.default.join(config.root, config.src)));
                    // 开发模式用 webpack-dev-middleware 获取 assets
                    app.use(function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
                        var assetsPath, assetsJson;
                        return __generator(this, function (_a) {
                            assetsPath = path_1.default.join(config.root, config.publish, config.static, config.assetsPath);
                            assetsJson = JSON.parse(res.locals.fs.readFileSync(assetsPath, 'utf-8'));
                            res.locals.assets = assetsJson;
                            next();
                            return [2 /*return*/];
                        });
                    }); });
                    return [3 /*break*/, 3];
                case 2:
                    // publish 目录启动
                    app.use(config.staticPath, express_1.default.static(path_1.default.join(config.root, config.static), config.staticOptions));
                    // 在根目录启动
                    app.use(config.staticPath, express_1.default.static(path_1.default.join(config.root, config.publish, config.static), config.staticOptions));
                    assets_1 = (0, assetsHelper_1.readAssets)(config);
                    app.use(function (req, res, next) {
                        res.locals.assets = assets_1;
                        next();
                    });
                    _d.label = 3;
                case 3:
                    // handle publicPath and default props
                    app.use(function (req, res, next) {
                        var basename = req.basename; // from shareRoot
                        var serverPublicPath = basename + config.staticPath;
                        var publicPath = config.publicPath || serverPublicPath;
                        var defaultProps = __assign(__assign({}, config), { basename: basename, publicPath: publicPath, serverPublicPath: serverPublicPath });
                        Object.assign(res.locals, defaultProps);
                        req.serverPublicPath = serverPublicPath;
                        req.publicPath = publicPath;
                        next();
                    });
                    // attach appSettings for client
                    app.use(function (req, res, next) {
                        var basename = req.basename, publicPath = req.publicPath;
                        var context = __assign(__assign({ basename: basename, publicPath: publicPath, staticPath: config.staticPath, restapi: config.restapi }, config.context), { preload: {}, assets: res.locals.assets });
                        res.locals.appSettings = __assign({ type: 'createHistory', basename: basename, context: context }, config.appSettings);
                        next();
                    });
                    return [2 /*return*/, app];
            }
        });
    });
}
exports.default = createExpressApp;
