/// <reference types="node" />
/**
 * 代码复制自：https://github.com/ptarjan/node-cache，用法跟其文档一致
 * 复制原因是，它只支持一个 cache 单例
 * 我们的需求是，每次调用，产生一个独立的实例
 */
export interface Cache {
    put: (key: string, value: any, time?: number, timeoutCallback?: (...props: any[]) => any) => any;
    del: (key: string) => boolean;
    clear: () => void;
    get: (key: string) => any;
    size: () => number;
    memsize: () => number;
    debug: (bool: boolean) => void;
    hits: () => number;
    misses: () => number;
    keys: () => string[];
}
export interface Record {
    value: any;
    expire: number;
    timeout?: NodeJS.Timeout | number;
}
declare const _default: () => Cache;
export default _default;
