"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function shareRoot() {
    var rootPathList = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        rootPathList[_i] = arguments[_i];
    }
    var matcherList = rootPathList.map(function (rootPath) {
        if (rootPath.charAt(rootPath.length - 1) === '/') {
            rootPath = rootPath.substr(0, rootPath.length - 1);
        }
        var ROOT_RE = new RegExp('^' + rootPath, 'i');
        return {
            rootPath: rootPath,
            ROOT_RE: ROOT_RE,
        };
    });
    var handler = function (req, res, next) {
        if (!req.basename) {
            req.basename = '';
        }
        for (var i = 0; i < matcherList.length; i++) {
            var _a = matcherList[i], rootPath = _a.rootPath, ROOT_RE = _a.ROOT_RE;
            if (ROOT_RE.test(req.url)) {
                req.url = req.url.replace(ROOT_RE, '');
                req.basename = rootPath;
                if (req.url.charAt(0) !== '/') {
                    req.url = '/' + req.url;
                }
                break;
            }
        }
        next();
    };
    return handler;
}
exports.default = shareRoot;
