"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var react_1 = __importDefault(require("react"));
var express_1 = require("express");
var server_1 = __importDefault(require("create-app/server"));
var server_2 = __importDefault(require("react-dom/server"));
var util_1 = require("../util");
function getModule(module) {
    return module.default || module;
}
function commonjsLoader(controller, location, context) {
    var ctrl = null;
    if ((0, util_1.isIMVCController)(controller) || (0, util_1.isThenable)(controller)) {
        ctrl = controller;
    }
    else {
        ctrl = controller(location, context);
    }
    if ((0, util_1.isThenable)(ctrl)) {
        return ctrl.then(getModule);
    }
    else {
        return getModule(ctrl);
    }
}
/**
 * controller 里会劫持 React.createElement
 * server side 场景缺乏恢复机制
 * 因此在这里特殊处理，在渲染完后，恢复 React.createElement
 */
var createElement = react_1.default.createElement;
function renderToNodeStream(view, controller) {
    if (typeof view === 'string') {
        return new Promise(function (resolve, reject) {
            resolve(Buffer.from((0, util_1.stringToUnit8Array)(view)));
        });
    }
    if (view === void 0 || view === null) {
        return new Promise(function (resolve, reject) {
            resolve(Buffer.from((0, util_1.stringToUnit8Array)('')));
        });
    }
    return new Promise(function (resolve, reject) {
        var stream = server_2.default.renderToNodeStream(view);
        var buffers = [];
        stream.on('data', function (chunk) { return buffers.push(chunk); });
        stream.on('end', function () {
            react_1.default.createElement = createElement;
            resolve(Buffer.concat(buffers));
        });
        stream.on('error', function (error) {
            if (!controller) {
                react_1.default.createElement = createElement;
                return reject(error);
            }
            if (controller.errorDidCatch) {
                controller.errorDidCatch(error, 'view');
            }
            if (controller.getViewFallback) {
                var fallbackView = controller.getViewFallback('view');
                renderToNodeStream(fallbackView).then(resolve, reject);
            }
            else {
                react_1.default.createElement = createElement;
                reject(error);
            }
        });
    });
}
function renderToString(view, controller) {
    if (typeof view === 'string') {
        return view;
    }
    if (view === void 0 || view === null) {
        return '';
    }
    try {
        return server_2.default.renderToString(view);
    }
    catch (error) {
        if (!controller)
            throw error;
        if (controller.errorDidCatch) {
            controller.errorDidCatch(error, 'view');
        }
        if (controller.getViewFallback) {
            var fallbackView = controller.getViewFallback();
            return renderToString(fallbackView);
        }
        else {
            throw error;
        }
    }
    finally {
        react_1.default.createElement = createElement;
    }
}
var renderers = {
    renderToNodeStream: renderToNodeStream,
    renderToString: renderToString,
};
function getRightPath(filePath) {
    var extensions = ['js', 'jsx', 'ts', 'tsx'];
    var finalFilePath = filePath;
    var clearFilePath = (0, util_1.getClearFilePath)(filePath, extensions);
    extensions.some(function (ets) {
        if (fs_1.default.existsSync("".concat(clearFilePath, ".").concat(ets))) {
            finalFilePath = "".concat(clearFilePath, ".").concat(ets);
            return true;
        }
        return false;
    });
    return finalFilePath;
}
function createPageRouter(options) {
    return __awaiter(this, void 0, void 0, function () {
        var config, routes, router, render, serverAppSettings, app, layoutView, setupDevEnv, handleRoutes, $routes;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    config = Object.assign({}, options);
                    routes = [];
                    if (!config.webpackDevMiddleware) {
                        routes = require(path_1.default.join(config.root, config.serverBundleName));
                    }
                    if (!Array.isArray(routes)) {
                        routes = Object.values(routes);
                    }
                    routes = (0, util_1.getFlatList)(routes);
                    router = (0, express_1.Router)();
                    render = renderers[config.renderMode] || renderToNodeStream;
                    serverAppSettings = {
                        loader: commonjsLoader,
                        routes: routes,
                        // @ts-ignore
                        viewEngine: { render: render },
                        context: {
                            isClient: false,
                            isServer: true,
                        },
                    };
                    app = (0, server_1.default)(serverAppSettings);
                    layoutView = config.layout
                        ? process.env.NODE_ENV !== 'production'
                            ? getRightPath(path_1.default.resolve(config.root, config.routes, config.layout))
                            : path_1.default.resolve(config.root, config.routes, config.layout)
                        : path_1.default.join(__dirname, 'view');
                    if (!(config.SSR === false)) return [3 /*break*/, 1];
                    router.all('*', function (req, res) {
                        res.render(layoutView);
                    });
                    return [3 /*break*/, 4];
                case 1:
                    if (!config.webpackDevMiddleware) return [3 /*break*/, 4];
                    return [4 /*yield*/, Promise.resolve().then(function () { return __importStar(require('../build/setupDevEnv')); })];
                case 2:
                    setupDevEnv = _a.sent();
                    handleRoutes = function ($routes) {
                        if (!$routes) {
                            return;
                        }
                        var routes = (0, util_1.getFlatList)(Array.isArray($routes) ? $routes : Object.values($routes));
                        app = (0, server_1.default)(__assign(__assign({}, serverAppSettings), { routes: routes }));
                    };
                    return [4 /*yield*/, setupDevEnv.setupServer(config, {
                            handleHotModule: handleRoutes,
                        })];
                case 3:
                    $routes = _a.sent();
                    handleRoutes($routes);
                    _a.label = 4;
                case 4:
                    // handle page
                    router.all('*', function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
                        var basename, serverPublicPath, publicPath, context, result, content, controller, initialState, htmlConfigs, data, finalLayoutPath, LayoutView, html, error_1;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    basename = req.basename, serverPublicPath = req.serverPublicPath, publicPath = req.publicPath;
                                    context = __assign(__assign({ basename: basename, serverPublicPath: serverPublicPath, publicPath: publicPath, staticPath: config.staticPath, restapi: config.serverRestapi || config.restapi || '' }, config.context), { preload: {}, isServer: true, isClient: false, req: req, res: res, assets: res.locals.assets });
                                    _a.label = 1;
                                case 1:
                                    _a.trys.push([1, 4, , 5]);
                                    return [4 /*yield*/, app.render(req.url, context)];
                                case 2:
                                    result = _a.sent();
                                    content = result.content;
                                    controller = result.controller;
                                    /**
                                     * 如果没有返回 content
                                     * 不渲染内容，controller 可能通过 context.res 对象做了重定向或者渲染
                                     */
                                    if (!content) {
                                        return [2 /*return*/];
                                    }
                                    return [4 /*yield*/, content];
                                case 3:
                                    // content 可能是异步渲染的
                                    content = _a.sent();
                                    initialState = controller.store ? controller.store.getState() : void 0;
                                    htmlConfigs = initialState ? initialState.html : void 0;
                                    data = __assign(__assign({}, htmlConfigs), { content: content, initialState: initialState });
                                    if (controller.destroy) {
                                        controller.destroy();
                                    }
                                    finalLayoutPath = res.locals.layoutView
                                        ? getRightPath(path_1.default.resolve(config.root, config.routes, res.locals.layoutView))
                                        : layoutView;
                                    LayoutView = getModule(require(finalLayoutPath));
                                    html = server_2.default.renderToStaticMarkup(react_1.default.createElement(LayoutView, __assign({}, res.locals, data)));
                                    if (!res.headersSent) {
                                        res.setHeader('Content-Type', 'text/html');
                                    }
                                    res.end("<!DOCTYPE html>".concat(html));
                                    return [3 /*break*/, 5];
                                case 4:
                                    error_1 = _a.sent();
                                    if (process.env.NODE_ENV !== 'production') {
                                        console.log(error_1);
                                    }
                                    next(error_1);
                                    return [3 /*break*/, 5];
                                case 5: return [2 /*return*/];
                            }
                        });
                    }); });
                    return [2 /*return*/, router];
            }
        });
    });
}
exports.default = createPageRouter;
