"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
process.env.BABEL_ENV = 'test';
process.env.NODE_ENV = 'test';
var jest_1 = __importDefault(require("jest"));
var yargs_1 = __importDefault(require("yargs"));
require("core-js/stable");
require("regenerator-runtime/runtime");
process.on('unhandledRejection', function (error) {
    throw error;
});
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var config_1 = __importDefault(require("../config"));
var config_defaults_1 = __importDefault(require("../config/config.defaults"));
// Makes the script crash on unhandled rejections instead of silently
// ignoring them. In the future, promise rejections that are not handled will
// terminate the Node.js process with a non-zero exit code.
var config = (0, config_1.default)(yargs_1.default.argv);
require('@babel/register')(__assign(__assign({}, config.babel(config_defaults_1.default)), { extensions: ['.es6', '.es', '.jsx', '.js', '.mjs', '.ts', '.tsx'] }));
var files = [];
function travelDirectoryToAddTestFiles(dir) {
    fs_1.default.readdirSync(dir).forEach(function (file) {
        var filename = path_1.default.join(dir, file);
        // ignore node_modules
        if (filename.indexOf('node_modules') !== -1) {
            return;
        }
        // read file deeply
        if (fs_1.default.statSync(filename).isDirectory()) {
            return travelDirectoryToAddTestFiles(filename);
        }
        // add *test.js file to the jest instance
        if (filename.substr(-8) === '.test.js' ||
            filename.substr(-8) === '.test.ts') {
            return files.push(filename);
        }
    });
}
travelDirectoryToAddTestFiles(process.cwd());
var options = Object.assign({
    roots: [process.cwd()],
    testRegexp: files,
}, yargs_1.default.argv);
jest_1.default
    .runCLI(options, [process.cwd()])
    .then(function (success) {
    console.log('test done');
})
    .catch(function (failure) {
    console.error(failure);
});
