"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * node server start file
 */
process.env.NODE_ENV = process.env.NODE_ENV || 'production';
require("core-js/stable");
require("regenerator-runtime/runtime");
var path_1 = __importDefault(require("path"));
var http_1 = __importDefault(require("http"));
var debug_1 = __importDefault(require("debug"));
var node_fetch_1 = __importDefault(require("node-fetch"));
var config_1 = __importDefault(require("../config"));
var server_1 = __importDefault(require("../entry/server"));
var createPageRouter_1 = __importDefault(require("../page/createPageRouter"));
function start(options) {
    return __awaiter(this, void 0, void 0, function () {
        /**
         * make fetch works like in browser
         * when url starts with //, prepend protocol
         * when url starts with /, prepend protocol, host and port
         */
        function fetchNative(url, options) {
            if (url.startsWith('//')) {
                url = 'http:' + url;
            }
            if (url.startsWith('/')) {
                url = "http://localhost:".concat(port).concat(url);
            }
            return (0, node_fetch_1.default)(url, options);
        }
        var config, _a, app, pageRouter, port, server, routePath, routes_1, addRenderPage, catch404, devErrorHandler, prodErrorHandler, promise;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    config = (0, config_1.default)(options);
                    return [4 /*yield*/, Promise.all([
                            (0, server_1.default)(config),
                            (0, createPageRouter_1.default)(config)
                        ])];
                case 1:
                    _a = _b.sent(), app = _a[0], pageRouter = _a[1];
                    port = normalizePort(config.port);
                    global.fetch = fetchNative;
                    /**
                     * set port from environment and store in Express.
                     */
                    app.set('port', port);
                    server = http_1.default.createServer(app);
                    routePath = path_1.default.join(config.root, config.routes);
                    if (hasModuleFile(routePath)) {
                        routes_1 = require(routePath);
                        routes_1 = routes_1.default || routes_1;
                        Object.keys(routes_1).forEach(function (key) {
                            var route = routes_1[key];
                            if (typeof route === 'function') {
                                route(app, server);
                            }
                        });
                    }
                    addRenderPage = function (req, res, next) {
                        res.renderPage = pageRouter;
                        next();
                    };
                    catch404 = function (req, res, next) {
                        var err = new Error('Not Found');
                        err.status = 404;
                        res.render('404', err);
                    };
                    devErrorHandler = function (err, req, res, next) {
                        res.status(err.status || 500);
                        res.send(err.stack);
                    };
                    prodErrorHandler = function (err, req, res, next) {
                        res.status(err.status || 500);
                        res.json(err.message);
                    };
                    app.use(addRenderPage);
                    app.use(pageRouter);
                    app.use(catch404);
                    // will print stacktrace
                    if (app.get('env') === 'development') {
                        app.use(devErrorHandler);
                    }
                    else {
                        app.use(prodErrorHandler);
                    }
                    promise = new Promise(function (resolve, reject) {
                        /**
                         * Event listener for HTTP server "listening" event.
                         */
                        var onListening = function () {
                            var addr = server.address();
                            var bind = typeof addr === 'string' ? 'pipe ' + addr : 'port ' + addr.port;
                            (0, debug_1.default)('Listening on ' + bind);
                            console.log('Listening on ' + bind);
                        };
                        /**
                         * Event listener for HTTP server "error" event.
                         */
                        var onError = function (error) {
                            if (error.syscall !== 'listen') {
                                throw error;
                            }
                            var bind = typeof port === 'string' ? 'Pipe ' + port : 'Port ' + port;
                            // handle specific listen errors with friendly messages
                            switch (error.code) {
                                case 'EACCES':
                                    console.error(bind + ' requires elevated privileges');
                                    process.exit(1);
                                    break;
                                case 'EADDRINUSE':
                                    console.error(bind + ' is already in use');
                                    process.exit(1);
                                    break;
                                default:
                                    throw error;
                            }
                        };
                        /**
                         * Listen on provided port, on all network interfaces.
                         */
                        server.listen(port);
                        server.on('error', onError);
                        server.on('listening', onListening);
                        server.on('error', reject);
                        server.on('listening', function () { return resolve({ server: server, app: app }); });
                    });
                    return [2 /*return*/, promise];
            }
        });
    });
}
exports.default = start;
/**
 * Normalize a port into a number, string, or false.
 */
function normalizePort(val) {
    var port = parseInt(String(val), 10);
    if (isNaN(port)) {
        // named pipe
        return val;
    }
    if (port >= 0) {
        // port number
        return port;
    }
    return void 0;
}
function hasModuleFile(filename) {
    try {
        return !!require.resolve(filename);
    }
    catch (_) {
        return false;
    }
}
