import type { Route } from 'create-app/client';
import type Controller from '../controller';
export type RouteList = Route[];
export type inputList = (Route | RouteList)[];
export declare function getFlatList(list: inputList): RouteList;
export interface FetchResponse {
    ok: boolean;
    status: number;
    statusText: string;
    json: () => Promise<object>;
    text: () => Promise<string>;
}
export declare function toJSON(response: FetchResponse): Promise<object>;
export declare function toText(response: FetchResponse): Promise<string>;
export declare function timeoutReject(promise: Promise<any>, time?: number, errorMsg?: string): Promise<any>;
export declare function isAbsoluteUrl(url: string): boolean;
export type mapFunction = (value: any, key: string) => any;
export type anyObject = {
    [key: string]: any;
};
export declare function mapValues(obj: anyObject, fn: mapFunction): anyObject;
export declare function isThenable(obj: any): boolean;
export declare function getPath(path: string | string[]): string[];
export interface ObjectOrArray {
    [key: string]: unknown;
}
export declare function setValue(obj: any, [key, ...rest]: string[], value: unknown): any;
export declare function setValueByPath(obj: any, path: string | string[], value: any): any;
export declare function getValue(ret: any, key: string | number): any;
export declare function getValueByPath(obj: any, path: string | string[]): any;
export declare function getKeys<T extends {}>(o: T): Array<keyof T>;
export declare function ab2str(buf: Uint8Array): string;
export declare function stringToUnit8Array(str: string): Uint8Array;
export declare function isAbsolutePath(path: string): boolean;
export declare function getClearFilePath(filepath: string, extensions?: string[]): string;
export declare function compareObject(a: object, b: object): boolean;
export declare function isIMVCController(fn: any): fn is Controller<any, any>;
